#include "rsa.h"

rsa_t rsa_init(size_t len) {
	rsa_t rsa;

	printf("Generating two primes of length %d bits\n", RSA_BLOCK_SIZE / 2);
	printf("Generating p...\n");
	rsa.p = bigint_prime(len / 2);
	printf("p = %u\n", rsa.p.data[0]);
	printf("Generating q...\n");
	rsa.q = bigint_prime(len / 2);
	printf("q = %u\n", rsa.q.data[0]);


	return rsa;
}

rsa_t rsa_generate_keys(size_t block_size) {
	size_t len = block_size / sizeof(uint32_t) / 8;
	rsa_t rsa = rsa_init(len);

	bigint_t a = bigint_zero(4);
	bigint_t b = bigint_zero(4);

	a.data[0] = 1234567890;
	b.data[0] = 234567;
	bigint_t result = assignable_bigint_modulo(a, b);

	printf("result is %ud\n", result.data[0]);

	bigint_destroy(a);
	a = bigint_clone(result);
	b.data[0] = 5764;

	printf("length\na: %lu e: %lu n: %lu\n", result.len, a.len, b.len);

	bigint_t result2 = assignable_bigint_pow_mod(result, a, b);
	bigint_destroy(a);
	bigint_destroy(b);
	bigint_destroy(result);
	printf("bigpowmod is %u \n", result2.data[0]);
	bigint_destroy(result2);
	return rsa;
}
